/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version: 1.3.21
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.osgeo.mapguide;



/**
 * The {@link MgdMapPlot} class allows the developer to specify the map,
 * the view of the map, the plot specification, and the layout
 * for one sheet within a call to GenerateMultiPlot.
 *
 */
 public class MgdMapPlot extends MgNamedSerializable {
  private long swigCPtr;

  public MgdMapPlot(long cPtr, boolean cMemoryOwn) {
    super(MapGuideDesktopApiJNI.SWIGMgdMapPlotToMgNamedSerializable(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected MgdMapPlot() {
    this(0, false);
  }

  protected void finalize() {
    delete();
  }

  public void delete() {
    if(swigCPtr != 0 && swigCMemOwn) {
      swigCMemOwn = false;
      MapGuideDesktopApiJNI.delete_MgdMapPlot(swigCPtr);
    }
    swigCPtr = 0;
    super.delete();
  }

  protected static long getCPtr(MgdMapPlot obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  
/**
 * Create and initialize an {@link MgdMapPlot} instance using
 * the map center and scale. Sets the MapPlotInstruction value
 * appropriately.
 *
 * @return  Nothing.
 */
 public MgdMapPlot(MgdMap map, MgdPlotSpecification plotSpec, MgdLayout layout) {
    this(MapGuideDesktopApiJNI.new_MgdMapPlot__SWIG_0(MgdMap.getCPtr(map), MgdPlotSpecification.getCPtr(plotSpec), MgdLayout.getCPtr(layout)), true);
  }

  
/**
 * Create and initialize an {@link MgdMapPlot} instance using
 * the specified center and scale.  Sets the MapPlotInstruction value
 * appropriately.
 *
 * @return  Nothing.
 */
 public MgdMapPlot(MgdMap map, MgCoordinate center, double scale, MgdPlotSpecification plotSpec, MgdLayout layout) {
    this(MapGuideDesktopApiJNI.new_MgdMapPlot__SWIG_1(MgdMap.getCPtr(map), MgCoordinate.getCPtr(center), scale, MgdPlotSpecification.getCPtr(plotSpec), MgdLayout.getCPtr(layout)), true);
  }

  
/**
 * Create and initialize an {@link MgdMapPlot} instance using
 * the specified extents  Sets the MapPlotInstruction value
 * appropriately.
 *
 * @return  Nothing.
 */
 public MgdMapPlot(MgdMap map, MgEnvelope extent, boolean expandToFit, MgdPlotSpecification plotSpec, MgdLayout layout) {
    this(MapGuideDesktopApiJNI.new_MgdMapPlot__SWIG_2(MgdMap.getCPtr(map), MgEnvelope.getCPtr(extent), expandToFit, MgdPlotSpecification.getCPtr(plotSpec), MgdLayout.getCPtr(layout)), true);
  }

  
/**
 * Get the {@link MgdMap} object to plot.
 *
 * @return  The {@link MgdMap} object.
 */
 public MgdMap getMap() {
    long cPtr = MapGuideDesktopApiJNI.MgdMapPlot_GetMap(swigCPtr);
    return (cPtr == 0) ? null : (MgdMap)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Set the {@link MgdMap} object to plot.
 *
 * @param  map ({@link MgdMap})  The {@link MgdMap} object to plot.
 * @return  Nothing
 */
 public void setMap(MgdMap map) {
    MapGuideDesktopApiJNI.MgdMapPlot_SetMap(swigCPtr, MgdMap.getCPtr(map));
  }

  
/**
 * Get the MapPlotInstruction, which defines how the view of the map
 * to be plotted is defined.
 *
 * @return  The MapPlotInstruction value.
 */
 public int getMapPlotInstruction() {
    return MapGuideDesktopApiJNI.MgdMapPlot_GetMapPlotInstruction(swigCPtr);
  }

  
/**
 * Set the MapPlotInstruction, which defines how the view of the map
 * to be plotted is defined.
 *
 * @param  plotInstruction (int)  The enumeration value defining  how the view of the map is defined.
 * @return  Nothing
 */
 public void setMapPlotInstruction(int plotInstruction) {
    MapGuideDesktopApiJNI.MgdMapPlot_SetMapPlotInstruction(swigCPtr, plotInstruction);
  }

  
/**
 * Get view center
 *
 * @return  The coordinates of the center of the view of map
 */
 public MgCoordinate getCenter() {
    long cPtr = MapGuideDesktopApiJNI.MgdMapPlot_GetCenter(swigCPtr);
    return (cPtr == 0) ? null : (MgCoordinate)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Get view scale
 *
 * @return  The scale of the view of map
 */
 public double getScale() {
    return MapGuideDesktopApiJNI.MgdMapPlot_GetScale(swigCPtr);
  }

  
/**
 * Set the view center and scale of the map.
 *
 * @param  center ({@link MgCoordinate})  The coordinates of the center of the view of the map.
 * @param  scale (double)  The scale of the view of the map.
 * @return  Nothing
 */
 public void setCenterAndScale(MgCoordinate center, double scale) {
    MapGuideDesktopApiJNI.MgdMapPlot_SetCenterAndScale(swigCPtr, MgCoordinate.getCPtr(center), scale);
  }

  
/**
 * Get extents of the view of the map.
 *
 * @return  The extents of the view of the map.
 */
 public MgEnvelope getExtent() {
    long cPtr = MapGuideDesktopApiJNI.MgdMapPlot_GetExtent(swigCPtr);
    return (cPtr == 0) ? null : (MgEnvelope)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Gets flag indicating whether extents of the view of the map
 * should be expanded to fill the space within the page margins.
 *
 * @return  The expand to fit flag.
 */
 public boolean getExpandToFit() {
    return MapGuideDesktopApiJNI.MgdMapPlot_GetExpandToFit(swigCPtr);
  }

  
/**
 * Set the extents of the map.
 *
 * @param  extent ({@link MgEnvelope})  The extents of the map.
 * @param  expandToFit (boolean/bool)  Flag indicating whether the extents should be  expanded to fill the space within the page margins.
 * @return  Nothing
 */
 public void setExtent(MgEnvelope extent, boolean expandToFit) {
    MapGuideDesktopApiJNI.MgdMapPlot_SetExtent(swigCPtr, MgEnvelope.getCPtr(extent), expandToFit);
  }

  
/**
 * Gets the plot specification.
 *
 * @return  The {@link MgdPlotSpecification}.
 */
 public MgdPlotSpecification getPlotSpecification() {
    long cPtr = MapGuideDesktopApiJNI.MgdMapPlot_GetPlotSpecification(swigCPtr);
    return (cPtr == 0) ? null : (MgdPlotSpecification)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Set the plot specification.
 *
 * @param  plotSpec ({@link MgdPlotSpecification})  The plot specification.
 * @return  Nothing
 */
 public void setPlotSpecification(MgdPlotSpecification plotSpec) {
    MapGuideDesktopApiJNI.MgdMapPlot_SetPlotSpecification(swigCPtr, MgdPlotSpecification.getCPtr(plotSpec));
  }

  
/**
 * Get the layout.  This value is optional; if null the map will fill
 * the entire page area within the margins.
 *
 * @return  The {@link MgdLayout}.
 */
 public MgdLayout getLayout() {
    long cPtr = MapGuideDesktopApiJNI.MgdMapPlot_GetLayout(swigCPtr);
    return (cPtr == 0) ? null : (MgdLayout)ObjectFactory.createObject(MapGuideDesktopApiJNI.getClassId(cPtr), cPtr, true);
  }

  
/**
 * Set the layout.
 *
 * @param  layout ({@link MgdLayout})  The object defining the layout for the plot.
 * @return  Nothing
 */
 public void setLayout(MgdLayout layout) {
    MapGuideDesktopApiJNI.MgdMapPlot_SetLayout(swigCPtr, MgdLayout.getCPtr(layout));
  }

}
